var searchBox;
var lastKeyPress=0;
//var visibleData=new Array();
/*All
 * ---------------
 * 0=Cell Text
 * 1=if 0, container, if 1, same level as container, 2=child of a container
 * 
 * Visible Data
 * ------------
 * 2=Opened or Closed(true or false)
 * 3=Label Pointer
 * 
 * Bookmarks(Child Data
 * ------------
 * 2=id
 * 3=url
 * 4=labels
 * 5=notes
 * 
 * New Class
 * ----------------
 * type
 * title
 * [id,url,labels,notes]
 * [toggled State, Pointer]
 */
var treeView;
var lblsTreeView;
var editField;
var editRow;
var editCol;
var editOriginalValue;
var cellOffset;
function GMarksTreeView(type,parent){
	this.type=type;
	if (parent && parent.length>0){
		this.parentLbl=parent;
		this.data=getTreeData(parent,true);
	}
	else
		this.data=getVisibleData();
	
	if (type=="complete")
		this.restoreContainers();
}
GMarksTreeView.prototype = {  
	//My vars
	rowsOpen: 0,
	//end my vars
  paremtLbl: null,
  treeBox: null,
  selection: null,
  //rowCount: function()                     { return visibleData.length; },
  get rowCount()                     { return this.data.length;},
  setTree: function(treeBox)         { this.treeBox = treeBox; },
  getCellText: function(idx, column) {
  	switch (column.id){
  		case "mainCol":
	 	case "nameCol":
		  	var title=this.data[idx].title;
			if (GMS.showCount && this.isContainer(idx)){
				title+=' ('+this.data[idx].data.length+')';
			}
			return title;
			break;
		case "urlCol":
			if (!this.isContainer(idx)){
				return this.data[idx].url;
			}
			else
				return "";
			break;
		case "notesCol":
			if (!this.isContainer(idx)){
				if (this.data[idx].notes)
					return this.data[idx].notes;
				else
					return "";
			}
			else
				return "";
			break;
		case "labelsCol":
			if (!this.isContainer(idx)){
				return this.data[idx].labels;
			}
			else
				return "";
			break;
		case "dateAddedCol":
			var dateLong=parseInt(this.data[idx].date/1000);
			var date;
			date=new Date()
			date.setTime(dateLong);
			return (date.getMonth()+1)+"/"+date.getDate()+"/"+date.getFullYear();
			break;
		case "visitedCol":
			return "";
			if (!this.isContainer(idx)){
				return this.data[idx].visited;
			}
			else
				return "";
			break;
		case "lastVisitedCol":
			return ""
			break;
		default:
			return "";
  	}
  	return "";
  },
  isContainer: function(idx)         {
  	if (idx<this.data.length && idx>=0)
  		 if (this.data[idx].type==0) return true;
  	return false;
  },
  isContainerOpen: function(idx)     { if (this.isContainer(idx)) return this.data[idx].open; else return false;},
  isContainerEmpty: function(idx)    { return false; },
  isSeparator: function(idx)         { return false; },
  isSorted: function()               { return false; },
  isEditable: function(idx, column)  {
  	if (this.isContainer(idx)){
		return column.id=="nameCol";
	}
  	switch (column.id){
	 	case "nameCol":
		case "urlCol":
		case "notesCol":
		case "labelsCol":
			return true;
			break;
		default:
			return false;
			break;
  	}
  	return false;	
  },
  getParentIndex: function(idx) {
  	if (idx>=this.data.length) return -1;
    if (this.getLevel(idx)==0) return -1;
	var curLevel=this.getLevel(idx);
    for (var t = idx - 1; t >= 0 ; t--) {
      if (this.isContainer(t) && this.getLevel(t)<curLevel) return t;
    }
    return -1;
  },
  getParentLabel: function(idx){
  	var parent=this.getParentIndex(idx);
  	if (parent>-1){
  		return this.data[parent].fullTitle;
  	}
  	else{
  		return this.parentLbl;
  	}
  },
  getLevel: function(idx) {
  	if (this.data[idx]!=null){
	    var level = this.data[idx].level;
	    if (this.type=="details")
	    	level--;
    	return level;
  	}
  	else{
  		dump("error getting level for "+idx+"/"+this.data.length+"\n");
  		return -1;
  	}
  },
  hasNextSibling: function(idx, after) {
    var thisLevel = this.getLevel(idx);
    for (var t = idx + 1; t < this.data.length; t++) {
      var nextLevel = this.getLevel(t)
      if (nextLevel == thisLevel) return true;
      else if (nextLevel < thisLevel) return false;
    }
    return false;
  },
  closeContainer: function(idx){
  	this.rowsOpen--;
  	this.data[idx].open = false;//Not open

  	var thisLevel = this.getLevel(idx);
  	var deletecount = 0;
  	for (var t = idx + 1; t < this.data.length; t++) {
    	if (this.getLevel(t) > thisLevel) {
			if (this.data[t].type==0) this.data[t].open=false;
			deletecount++;
    	}
		else break;
  	}
  	if (deletecount) {
    	this.data.splice(idx + 1, deletecount);
  	}
  	return deletecount;
  },
  openContainer: function(idx){
  	//dump("open "+this.data[idx].fullTitle+"\n");
  	this.data[idx].open = true;
  	if (this.data[idx].level==0) this.rowsOpen++;

	var toinsert = this.data[idx].data;
	var lvl=this.data[idx].level+1;
	if (toinsert || true){
	  	for (var i = 0; i < toinsert.length; i++) {
			if (toinsert[i].type!=null && toinsert[i].type==0)
				this.data.splice(idx + i + 1, 0, toinsert[i]);
			else{		
	    		if (this.type!="labels") 
	    			this.data.splice(idx + i + 1, 0,  new BookmarkData(2,toinsert[i],lvl));
	    		else
	    			return i;
			}
	  	}
	  	//dump("Opened Container - "+toinsert.length+"\n");
	  	return toinsert.length;
	}
	else
		return 0;
  },
  expand: function(idx,fromPopup){
  	var length=0;
  	var level=this.data[idx].level;
  	if (!this.isContainerOpen(idx))
  		length+=this.openContainer(idx);
  	//dump(this.data[idx].title+" is container: "+this.isContainer(idx)+"\n");
  	//dump(this.data[idx].title+" level: "+this.data[idx].level+"\n");
  	idx++;
  	while(idx<this.data.length && this.data[idx].level>level){
  		if (this.isContainer(idx)){
  			if (!this.isContainerOpen(idx))
  				length+=this.openContainer(idx);
  		}
  		idx++;
  	}
  	this.treeBox.rowCountChanged(idx + 1, length);
  	if (fromPopup){
		var lastRow=this.treeBox.getLastVisibleRow();
		if (idx>lastRow){
			//dump("scroll down!\n");
			this.treeBox.scrollByLines(idx-lastRow);
		}
  	}
  	return length;
  },
  toggleOpenState: function(idx) {
    //if (!item[1]) return;
    if (!this.isContainer(idx)) return;

    if (this.data[idx].open) {
     	 //We close it
      	var deletecount=this.closeContainer(idx);
      	if (deletecount)
      		this.treeBox.rowCountChanged(idx + 1, -deletecount);
    }
    else {
      	var length=this.openContainer(idx);
      	this.treeBox.rowCountChanged(idx + 1, length);
		var lastRow=this.treeBox.getLastVisibleRow();
		if (idx+1+length>lastRow){
			//dump("scroll down!\n");
			this.treeBox.scrollByLines((idx+1+length)-lastRow);
		}
    }
    this.selection.select(idx);
  },
  openAll: function(change){
  	if (change!=false)
  		this.treeBox.beginUpdateBatch();	
  	for (var i=0;i<this.data.length;i++){
		if (this.isContainer(i) && !this.isContainerOpen(i)){
			this.openContainer(i);
		}
	}
	if (change!=false)
		this.treeBox.endUpdateBatch();		
  },
  closeAll: function(change){
  	if (change!=false)
		this.treeBox.beginUpdateBatch();	
  	for (var i=0;i<this.data.length;i++){
		if (this.isContainerOpen(i)){
			this.closeContainer(i);
		}
	}
	if (change!=false)
		this.treeBox.endUpdateBatch();	
  },
  toggleAll: function(){
  	this.treeBox.beginUpdateBatch();	
  	if (this.rowsOpen==0){
  		//Open all rows
  		this.openAll(false);
  	}
  	else{
  		//Close all rows
  		this.closeAll(false);
  	}
  	this.treeBox.endUpdateBatch();	
  },
  getImageSrc: function(idx, column) {
  	if (this.isContainer(idx) || !GMS.showIcons || !GMS.showFavs) return null;
	//dump("img idx="+idx+"\n");
	//dump(this.data[idx].url+"  -  "+this.data[idx].image+'\n');
	if (column.id=="mainCol" || column.id=="nameCol")
		if (this.data[idx])
			return this.data[idx].image;
	return null;
  },
    
  getProgressMode : function(idx,column) {},
  getCellValue: function(idx, column) {},
  cycleHeader: function(col, elem) {},
  selectionChanged: function() {},
  cycleCell: function(idx, column) {},
  performAction: function(action) {},
  performActionOnCell: function(action, index, column) {},
  
  getRowProperties: function(idx, column, prop) {},
  getCellProperties: function(idx, column, prop) {
  	if (column.id=="mainCol" || column.id=="nameCol"){
	  	var aserv=Components.classes["@mozilla.org/atom-service;1"].getService(Components.interfaces.nsIAtomService);
	  	if (GMS.showIcons==true){
		  prop.AppendElement(aserv.getAtom("showIcon"));
		  if (GMS.readerLabel==this.data[idx].fullTitle)
		  	prop.AppendElement(aserv.getAtom("starredInReader"));
	  	}
	  	if (this.type=="labels" && this.data[idx].type==0){
	  		if (this.data[idx].data[0].type!=0){
	  			prop.AppendElement(aserv.getAtom("hideTwisty"));
	  		}
	  	}
	  	//starredInReader
	  	//prop.AppendElement('container="true"');
  	}
  },
  getColumnProperties: function(column, element, prop) {},
  
  canDrop : function(idx, orient) {
  	//return !orient; 
  	if (idx<this.data.length){
  		if (this.isContainer(idx)){
  			if (orient==0)
  				return true;
  		}
  		else
  			return true;
  	}
  	return false;
  },
  drop : function(index, orient) {
  	dump("Drag source: "+dragSource+"\n");
  	if ( !treeDrag) return;
  	//var dragIndex=document.getElementById("gmarkList").currentIndex;
  	dump("drop-"+index+"|"+orient+"|"+dragIndex+"\n"); 
  	var source=getTreeView(dragSource);
  	dump("source="+source.type+"\n");
  	var label;
  	if (this.isContainer(index))
  		label=this.data[index].fullTitle;
  	else if (this.data[index].type==2){
  		var parent=this.getParentIndex(index);
  		if (parent != -1)
  			label=this.data[parent].fullTitle;
		else
			label=this.getParentLabel(index);
  	}
  	//Add Label to Bookmark(s)
  	var bm=new Array();
  	if (source.isContainer(dragIndex))
  		bm=source.data[dragIndex].data;
  	else
		bm.push(source.data[dragIndex]);
  		//bm.push(this.getBookmark(dragIndex));
  	if (label==null || label=="") return;
	
	addLabelFromDaD(bm,label);
		
  	dump("dragged onto label: "+label+"\n");
  },
  //Custom stuff
  getURL: function(idx){return this.data[idx].url;},
  getBookmark: function(idx){
  	return this.data[idx];
	//return new bookmark(this.data[idx][2],this.data[idx][3],this.data[idx][0],this.data[idx][4],this.data[idx][5]);
  },
  restoreContainers: function(lbls){
  	lbls=lbls ? lbls : prefs.getCharPref(".labels").split(/\s*,\s*/);
  	this.rowsOpen=0;
  	for (var i=0;i<this.data.length;i++){
  		if (this.data[i].type==0){
  			var idx=lbls.indexOf(this.data[i].fullTitle);
  			if (idx>-1){
  				this.openContainer(i);
  				lbls.splice(idx,1);
  			}
  		}
  	}
  },
  getOpened: function(){
  	var lbls=new Array();
  	for (var i=0;i<this.data.length;i++){
  		if (this.isContainerOpen(i)){
  			lbls.push(this.data[i].fullTitle);
  		}
  	}
  	return lbls;
  },
  saveOpened: function(){
  	prefs.setCharPref(".labels",this.getOpened().join(','));
  }
};
function expand(event){
	var tree=document.popupNode.parentNode;
	getTreeView(tree).expand(pops.getLabelIndex(),true);
}
function addLabelFromDaD(bkmks, lbl,refresh){
	//dump("Bkmks: "+bkmks+"\n");
	for (var i=0;i<bkmks.length;i++){
		//dump("title["+i+"] "+bkmks[i].title+"\n");
		//dump("Type: "+bkmks[i].type+"\n");
		if (bkmks[i].type==0){
			if (i==bkmks.length-1 && refresh==null) refresh=true;
			addLabelFromDaD(bkmks[i].data,lbl,refresh==true);
		}
		else{
			if (refresh==null) refresh=true;
			//GMS.onRenameLabel(label.fullTitle,newLabel,refresh==true);
			GMS.addLabelToBookmark(GMS.getBookmark(bkmks[i].url),lbl,i==bkmks.length-1 && refresh==true);
			//dump('add label '+bkmks[i].title+"\n");
		}	
	}
}
function treeInit() {
	//dump("initiated\n");
	var tree = document.getElementById("gmarkList");
	treeView=new GMarksTreeView("complete");
	tree.view = treeView;
	tree.selType="single";
}

function openIn(where){
	var url;
}

//chrome://browser/content/utilityOverlay.js
function getTreeView(tree){
	if (typeof tree == 'string'){
		if (tree=="complete" || tree=="details")
			return treeView;
		else
			return lblsTreeView;
	}
	else{
		var treeId=tree.getAttribute('id');
		if (treeId=="gmarkList" || treeId=="gmarkDetails")
			return treeView;
		else
			return lblsTreeView;
	}
}
function isRightClick(event){
	if (navigator.appVersion.indexOf("Mac")!=-1){
		if (event.ctrlKey==true && event.button==0)
			return true;
	}
	else if (event.button==2)
		return true;
	
	return false;
}
function mouseClick(event){
	/*
	var consoleService = Components.classes["@mozilla.org/consoleservice;1"]
    		.getService(Components.interfaces.nsIConsoleService);
  	consoleService.logStringMessage("GMarks: button=" + event.button+"\nwhich: "+event.which+"\n"+
  		"altKey: "+event.altKey+"\nctrlKey: "+event.ctrlKey+"\nmetaKey: "+event.metaKey+"\nshiftKey: "+event.shiftKey+"\n"+
  			"platform: "+navigator.appVersion);
	*/
	var tree=event.target.parentNode;//document.getElementById("gmarkList");
	//for (var p in event){
	//	dump(p+" = "+event[p]+"\n");
	//}
	var row = {}, col = {}, obj = {};
	tree.treeBoxObject.getCellAt(event.clientX, event.clientY, row, col, obj);
	var visibleData=getTreeView(tree).data;
	if (getTreeView(tree).type=="details" && !editField.getAttribute("hidden")==true){
		//assignValueToCell(editField.value,true);
		//editField.setAttribute("hidden","true");
		//if (editRow!=-1)
		if (!editRow==row.value || !editCol==col.value)
			fieldChange();
		else{
			
			return;
		}
		dump("field hidden\n");
	}
	if (row.value>=0 && row.value<visibleData.length){

		if (obj.value){
			var sel;
			if (obj.value.toString()!='twisty')
				sel=tree.currentIndex;
			else
				sel=row.value;

	  		if (!tree.view.isContainer(sel)){
	  			if (isRightClick(event)){
	  				//Right Click Bookmark
					var popup=document.getElementById("gm-bookmarkPopup");

					var remLbl=document.getElementById("remLbl");
					if (visibleData[sel].labels.length>0 && 
							visibleData[sel].labels.indexOf(GMS.readerLabel)==-1){
						remLbl.setAttribute("disabled","false");
					}
					else{
						remLbl.setAttribute("disabled","true");
					}
					
					if (visibleData[sel].labels.indexOf(GMS.readerLabel)!=-1){
						remLbl.previousSibling.setAttribute("disabled","true");
						remLbl.previousSibling.previousSibling.setAttribute("disabled","true");
						remLbl.nextSibling.setAttribute("disabled","true");
						remLbl.nextSibling.nextSibling.nextSibling.setAttribute("disabled","true");
					}
					else{
						remLbl.previousSibling.setAttribute("disabled","false");
						remLbl.previousSibling.previousSibling.setAttribute("disabled","false");
						remLbl.nextSibling.setAttribute("disabled","false");
						remLbl.nextSibling.nextSibling.nextSibling.setAttribute("disabled","false");
					}
					tree.setAttribute("context","gm-bookmarkPopup");
	  			}
	  			else{//if (event.button<2){
					//Open
					if (tree.getAttribute("id")=="gmarkList")
						openBookmark(getTreeView(tree).getURL(sel),event);
				}
			}
			else{
				if (isRightClick(event)){
					popup=document.getElementById("gm-labelPopup");
					var renameLbl=document.getElementById("renameLbl");
					var delLbl=document.getElementById("delLabel");
					var addHere=document.getElementById("addHere");
					var delBkmks=document.getElementById("delBkmks");
					if (visibleData[sel].fullTitle==GMS.unlabeled || visibleData[sel].fullTitle==GMS.readerLabel){
						renameLbl.setAttribute("disabled","true");
						delLbl.setAttribute("disabled","true");
						if ( visibleData[sel].fullTitle==GMS.readerLabel){
							addHere.setAttribute("disabled","true");
							delBkmks.setAttribute("disabled","true");
						}
						else{
							addHere.setAttribute("disabled","false");
							delBkmks.setAttribute("disabled","false");
						}
					}
					else{
						renameLbl.setAttribute("disabled","false");
						delLbl.setAttribute("disabled","false");
						addHere.setAttribute("disabled","false");
						delBkmks.setAttribute("disabled","false");
					}
					tree.setAttribute("context","gm-labelPopup");
				}
				else if (event.button==1)
					openInTabs(event);
				else if (event.button==0){
					switchView(tree);
				}
			}
	    }
	    else{
	    	//not on the tree
	    	dump("not in the window\n");
	    	tree.setAttribute("context",null);
	    }
	}
}

function switchView(tree){
	if (tree.getAttribute("id")=="gmarkLabels"){
		//dump("index: "+tree.currentIndex+"\n");
		treeView.treeBox.beginUpdateBatch();
		//dump("label: "+lblsTreeView.data[tree.currentIndex].fullTitle+"\n");
		treeView.parentLbl=lblsTreeView.data[tree.currentIndex].fullTitle;
		treeView.data=getTreeData(treeView.parentLbl,true);
		treeView.treeBox.endUpdateBatch();
		treeView.openAll();
	}
}
function doubleClick(event){
	/*
	var tree=event.target.parentNode;
	var row = {}, col = {}, obj = {};
	tree.treeBoxObject.getCellAt(event.clientX, event.clientY, row, col, obj);
	var visibleData=getTreeView(tree).data;
	if (row.value>=0 && row.value<visibleData.length){
		var x = {}, y = {}, width = {}, height = {};
		//if (typeof tree.columns != "undefined") column = tree.columns[column];
		tree.boxObject.getCoordsForCellItem( row, col, obj, x, y, width, height );
		editField.setAttribute("hidden","false");
		dump("text: "+treeView.getCellText(row.value,col.value)+"\n");
		editField.value=treeView.getCellText(row.value,col.value);
		//editField.width=width.value;
		//editField.height=height.value;
		//editField.left=x.value;
		//editField.top=y.value;
		dump("top="+y.value+" left="+x.value+" width="+width.value+" height="+height.value+" part="+obj.value+"\n");
	}*/
	var treeBox = event.target.parentNode.treeBoxObject;
    var row = {};
    var col = {};
    var obj = {};
    treeBox.getCellAt(event.clientX,event.clientY,row,col,obj);
	if (getTreeView(event.target.parentNode).isEditable(row.value,col.value))
    	setEditMode(row.value,col.value,true);
}

function setEditMode(x,y,val){
	if (val){
		if (x < 0) return;

		if (editRow >= 0) assignValueToCell(editField.value,true);
		
		editField.removeAttribute("hidden");
		
		
		
		var treeBox = treeView.treeBox;
		var tree=treeBox.treeBody.parentNode;
		var outx = {}, outy = {}, outwidth = {}, outheight = {};
		var offset;
		//dump("tree: "+tree+" - "+tree.tagName+"\n");
		offset=tree.columns["nameCol"].element.boxObject.height;
		//dump("offset: "+offset+"\n");
		var coords = treeBox.getCoordsForCellItem(x,y,"text",outx,outy,outwidth,outheight);
		
		editRow = x;
		editCol = y;
		var originalValue = treeView.getCellText(x,y);
		//originalValue="zzzzzzzzzAFEVCJDGHCVDJCSDSDUSGSJSKGHS";
		//dump("setEditMode("+x+","+y+"):  X:"+outx.value+" Y:"+outy.value+" W:"+outwidth.value+" H:"+outheight.value+"\n"); 
		
		outheight.value=26;
		outy.value+=offset;//30;
		if (GMS.showIcons && y.id=="nameCol")
			outx.value+=3;
		editField.setAttribute("left",outx.value-3);
		editField.setAttribute("top",outy.value-3);
		editField.setAttribute("height",outheight.value);
		
		var txtLeft=outx.value-3;
		
		var coords = treeBox.getCoordsForCellItem(x,y,"cell",outx,outy,outwidth,outheight);
		
		txtLeft=0;
		if (GMS.showIcons && y.id=="nameCol"){
			//dump("name col\n");
			outwidth.value-=36;
		}
		editField.setAttribute("width",outwidth.value); // - outy.value
		//dump(" real w: "+(outwidth.value-outy.value)+"\n");
		//dump("setEditMode2("+x+","+y+"): X:"+outx.value+" Y:"+outy.value+" W:"+outwidth.value+" H:"+outheight.value+"\n");
		editOriginalValue = originalValue;
		
		editField.value = originalValue;
		editField.select();
		document.getElementById("gmarkDetails").setAttribute("editing","true");
		editField.focus();
		
		dump("\nLeft: "+editField.getAttribute("left")+"\nTop: "+editField.getAttribute("top")+
			"\nHeight: "+editField.getAttribute("height")+"\nWidth: "+editField.getAttribute("width")+
			"\nValue: "+editField.value+"\n\n");
		
		editField.addEventListener("keydown", fieldKeyDown, false);
		editField.addEventListener("blur", fieldChange, true);
		assignValueToCell("",false);
		
	}
	else {
		document.getElementById("gmarkDetails").removeAttribute("editing");
		
		editField.setAttribute("hidden","true");
		editField.removeEventListener("keydown", fieldKeyDown, false);
		editField.removeEventListener("blur", fieldChange, true);
	    editField.blur();
	    treeView.selection.select(editRow);
	    editRow=-1;
	    dump("Hide edit field\n");
	}
}
function assignValueToCell(value, acceptMode){
	if (editRow == -1) return;
	if (value!=null){
		var update=value!=editOriginalValue && acceptMode;
		var bkmk=treeView.data[editRow];
		switch (editCol.id){
		 	case "nameCol":
			  	if (bkmk.type==0 && update){
			  		renameLabel(bkmk,value,true,null);
			  	}
			  	else
			  		bkmk.title=value;
				break;
			case "urlCol":				
				if (update){
			    	GMS.onRemoveBookmark(bkmk,null,false);
			    	bkmk.url=value;
				}
				else
					bkmk.url=value;
				break;
			case "notesCol":
				bkmk.notes=value;
				break;
			case "labelsCol":
				bkmk.labels=value.split(/\s*,\s*/);		
				break;
			default:
				return;
	  	}
		
		//if (bkmk.labels.join(",")==value.split(/\s*,\s*/).join(','))
		//				return;
		dump("setCellText: "+value+"\n");
		//treeView.setCellText(editRow,editCol,value);
		treeView.treeBox.invalidateCell(editRow,editCol);
		if (update){
			if (bkmk.type!=0){//Not Container
				
				//GMS.updateBookmark(bkmk,true);
				GMS.doCommand("quickrefresh");
				GMS.sendUpdateBookmark(bkmk);
			}
			dump("sent update\n");
		}
		if (acceptMode){
			//editRow = -1;
			dump("normal\n");
			editCol = null;
			setEditMode(0,0,false);//"normal"
		}
	}
	else{
		//editRow = -1;
		dump("assign value to cell -clear\n");
		editCol = null;
		setEditMode(0,0,false);//"normal"
	} 
}
function fieldKeyDown(event){
	//var tree=document.getElementById("gmarkDetails"); //event.target.nextSibling.tagName
	dump("fieldKeyDown: "+editField.getAttribute("width")+"\n");
	//var tree = event.target;
	//while (tree && tree.tagName != "tree") tree = tree.parentNode;
    if (event.keyCode == 13){
    	assignValueToCell(editField.value,true);
    }
    if (event.keyCode == 27){
    	assignValueToCell(null,false);
    }
  	event.preventBubble();
}
function fieldChange(event){
	//var tree=document.getElementById("gmarkDetails");
	//dump("fieldChange: "+event.target.nextSibling.tagName+"\n");
	//var tree = event.target;
	//while (tree && tree.tagName != "tree") tree = tree.parentNode;
	dump("field Change\n");
  	assignValueToCell(editField.value,true);
}
function keyPress(event){
	var tree=event.target;
	//dump("tree: "+tree+" "+tree.tagName+"\n");
	var sel=tree.currentIndex;
	var visibleData=getTreeView(tree).data;
	if (sel<0 || sel>visibleData.length) return;
	var container=getTreeView(tree).isContainer(sel);
	switch (event.keyCode){
		case 13:
			if (!container){
				openBookmark(getTreeView(tree).getURL(sel),event);
			}
			break;
		case 46:
			if (!container){
				GMS.onRemoveBookmark(visibleData[sel],null,true);
			}
			else{
				removeLabel(visibleData[sel]);
			}
			break;
		case 37:
		case 38:
		case 39:
		case 40:
			setTimeout(function(){switchView(tree);},10);
			break;
		default:
			//dump(event.keyCode+"\n");
			
	}
	
}

function openBookmark(url,event){
	var bookmarkPrefs=Components.classes["@mozilla.org/preferences-service;1"].
                            getService(Components.interfaces.nsIPrefService).getBranch("extensions.tabmix.");
	var bkmkNewTab;
	try{
		bkmkNewTab=bookmarkPrefs.getBoolPref("opentabfor.bookmarks");
	}
	catch(e){bkmkNewTab=false;}
	bkmkNewTab=bkmkNewTab || prefs.getBoolPref('.openinnewtab');
	if (!bkmkNewTab)
		openUILink(url,event,false,true);
	else{
		if (event.shiftKey==true)
			openUILinkIn(url,"tabshifted");
		else
			openUILinkIn(url,"tab");
	}
}

function openInTabs(event){
	var x,y;
	if (!event){
		var popup=document.getElementById("gm-labelPopup");
		x=popup.boxObject.x;
		y=popup.boxObject.y;
	}
	else{
		x=event.clientX;
		y=event.clientY;
	}		
	
	var tree=document.popupNode.parentNode;
	var row = {}, col = {}, obj = {};
	tree.treeBoxObject.getCellAt(x, y, row, col, obj);
	var sel=row.value;
	var visibleData=getTreeView(tree).data;
	var labelArray = new Array();	
	labelArray = visibleData[sel].data;   
	for (var i = 0; i < labelArray.length; i++)
		openUILinkIn(labelArray[i].url, "tabshifted");
}

function removeLabelFromBookmark(){
	var tree=document.popupNode.parentNode;
	var visibleData=getTreeView(tree).data;
	var index=pops.getBookmarkIndex();
	//var parent=getTreeView(tree).getParentIndex(index);
	var label=getTreeView(tree).getParentLabel(index);//visibleData[parent].fullTitle
	GMS.removeLabelFromBookmark(visibleData[index],label,true);
}

function renameLabel(label, newLabel,refresh,event){
	if (!label){
		var tree=document.popupNode.parentNode;
		var visibleData=getTreeView(tree).data;
		label=visibleData[pops.getLabelIndex(event)];
	}
	newLabel = newLabel ? newLabel : prompt(strbundle.getString("renameLabel"),label.fullTitle);
	if (!newLabel || newLabel=="") return;
	
	var data=label.data;

	for (var i=0;i<data.length;i++){
		dump(data[i].type+"\n");
		if (data[i].type==0){
			if (i==data.length-1 && refresh==null) refresh=true;
			renameLabel(data[i],newLabel+nestedChar+data[i].title,refresh==true);
		}
		else if (data[i].type==null){
			if (refresh==null) refresh=true;
			GMS.onRenameLabel(label.fullTitle,newLabel,refresh==true);
			break;	
		}	
	}
	dump("finished renaming "+label.fullTitle+" to "+newLabel+"\n");
}

function removeLabel(label, refresh,event){
	if (!label){
		var tree=document.popupNode.parentNode;
		var visibleData=getTreeView(tree).data;
		label=visibleData[pops.getLabelIndex(event)];
	}
	//if (!confirm(strbundle.getString("removeLabel")+" \""+label.fullTitle+"\"?")) return;
	
	var data=label.data;

	for (var i=0;i<data.length;i++){
		if (data[i].type==0){
			if (i==data.length-1 && refresh==null) refresh=true;
			removeLabel(data[i],refresh==true);
		}
		else if (data[i].type==null){
			if (refresh==null) refresh=true;
			GMS.onRemoveLabel(label.fullTitle,refresh);
			break;	
		}	
	}
}

function removeLabelAndBookmarks(label, refresh,event){
	if (!label){
		var tree=document.popupNode.parentNode;
		var visibleData=getTreeView(tree).data;
		label=visibleData[pops.getLabelIndex(event)];
	}
	dump("label="+label.title+"\n");
	var data=label.data;

	for (var i=0;i<data.length;i++){
		if (data[i].type==0){
			if (i==data.length-1 && refresh==null) refresh=true;
			removeLabelAndBookmarks(data[i],refresh==true);
		}
		else if (data[i].type==null){
			if (i==data.length-1){
				if (refresh==null) refresh=true;
			}
			else if (refresh==true) refresh=null; 
	    	GMS.onRemoveBookmark(data[i],null,refresh==true);
		}
	}
}

var pops={
	getIndex: function(x,y,tree){
		var row = {}, col = {}, obj = {};
		//var tree=event.target.parentNode;
		tree.treeBoxObject.getCellAt(x, y, row, col, obj);
		
		return row.value;
	},
	getEventIndex:  function(event){
		return this.getIndex(event.clientX,event.clientY,event.target.parentNode);
	},
	getPopupIndex: function(id,event){
		var popup=document.getElementById(id);
		var x=popup.boxObject.x;
		var y=popup.boxObject.y;
		
		var tree=document.popupNode.parentNode;
		var visibleData=getTreeView(tree).data;
		
		var index=this.getIndex(x,y,tree);
		if (index!=null && index>=0 && index<=visibleData.length)
			index=tree.currentIndex;
		else
			index=-1;
			
		return index;
	},
	getBookmarkIndex: function(event){
		return this.getPopupIndex("gm-bookmarkPopup",event);
	},
	getLabelIndex: function(event){
		return this.getPopupIndex("gm-labelPopup",event);
	},
	getID: function(event){
		var tree=document.popupNode.parentNode;
		var visibleData=getTreeView(tree).data;
		return visibleData[this.getBookmarkIndex(event)].id;
	},
	getURL: function(target){
		var tree=document.popupNode.parentNode;
		///dump("tree: "+target.tagName+" - "+tree.tagName+" - "+document.popupNode.tagName+"\n");
		var visibleData=getTreeView(tree).data;
		var idx=this.getBookmarkIndex();
		dump("URL: " + visibleData[idx].url+" - "+idx+"\n");
		return visibleData[idx].url;
	},
	getLabels: function(event){//For bookmarks
		var tree=document.popupNode.parentNode;
		var visibleData=getTreeView(tree).data;
		return visibleData[this.getBookmarkIndex(event)].url;
	},
	getNotes: function(event){
		var tree=document.popupNode.parentNode;
		var visibleData=getTreeView(tree).data;
		return visibleData[this.getIBookmarkndex(event)].notes;
	},
	getBookmark: function(event){
		var tree=document.popupNode.parentNode;
		var visibleData=getTreeView(tree).data;
		var vis=visibleData[pops.getBookmarkIndex()];
		var bm=GMS.createNewBookmark(vis.id,vis.url,vis.title,vis.labels,vis.notes)//new bookmark(vis.id,vis.url,vis.title,vis.labels,vis.notes);
		
		return bm;
		//return visibleData[pops.getBookmarkIndex()];
	},
	
	//For...lables....(the containers)...
	getLabel: function(event){
		var tree=document.popupNode.parentNode;
		var visibleData=getTreeView(tree).data;
		var lbl=visibleData[this.getLabelIndex(event)].fullTitle;
		if (lbl==GMS.unlabeled) lbl="";
		return lbl;
	}
}

function doSearch(){
	var search=searchBox.value;
	dump('do search-'+search+'\n');
	
	if (search.length==0){
		//Normal view
		treeView.treeBox.beginUpdateBatch();
		if (treeView.type=="complete"){
			treeView.data=getVisibleData();
		}
		else{
			treeView.data=getTreeData(treeView.parentLbl,true);
		}
		treeView.treeBox.endUpdateBatch();
	}
	else {
		
		GMS.getSiteSearch(search,"quickrefresh",true);
	}
	
}

function updateNotes(){
	if (searchBox.value.length==0)
		treeView.data=updateChildNotes(treeView.data);
	else{
		for (var i=0;i<GMS.searchArray.length;i++){
			treeView.data[i].notes=GMS.searchArray[i].notes;
			if (GMS.searchArray[i].notes.length>0){
				var bkmk=GMS.searchArray[i];
				//dump("bkmk: "+bkmk.title+" notes: "+bkmk.notes+"\n");
			}
		}
		treeView.treeBox.invalidate();
		dump("update notes complete\n");
	}
}

function updateChildNotes(vData){
	for (var v=0;v<vData.length;v++){
		if (vData[v].type > 0 || vData[v].type==null){
			var index=GMS.isBookmarked(vData[v].url);
			vData[v].notes=GMS.bookmarkArray[index].notes;													
		}
		else if (vData[v].type==0)
			vData[v].data=updateChildNotes(vData[v].data);
	}
	return vData;
}
function doSidebarUnload(){
	if (gmarksObserver!=null) gmarksObserver.unregister();
	if (treeView!=null)
		treeView.saveOpened();
}
function doOrganizeUnload(){
	if (gmarksObserver!=null) gmarksObserver.unregister();
}

function doSidebarLoad(){
	GMS=Components.classes["@mozilla.org/gmarks;1"]
                     .getService(Components.interfaces.nsIGMarksService).wrappedJSObject;
	strbundle=document.getElementById("gmarksBundle");
	if (prefs.getBoolPref('.showAddBookmark')==false){
		document.getElementById('addGMark').setAttribute('hidden','true');
	}
	else{
		document.getElementById('addGMark').setAttribute('hidden','false');
	}

	searchBox=document.getElementById('txtSearch');
	searchBox.focus();
	gmarksObserver=new GmarksObserverControl();
	GMS.isSignedIn=GMS.checkSignedCookie();
	if (GMS.bookmarkArray.length>0) 
		GM.onLoad();
	else if (!GMS.isSignedIn){
		var container=document.getElementById("signedOffContainer");
		container.setAttribute("hidden","false");
		var pass=GMS.getPassInfo();
		if (pass){
			document.getElementById("txtEmail").value=pass.user;
			document.getElementById("txtPassword").value=pass.password;
		}
		document.getElementById("gmarkList").setAttribute('hidden','true');
	}
}
function doOrganizeLoad(){
	GMS=Components.classes["@mozilla.org/gmarks;1"]
                     .getService(Components.interfaces.nsIGMarksService).wrappedJSObject;
	strbundle=document.getElementById("gmarksBundle");
	//window.height=800
	//window.width=1200;
	//window.setAttribute('height','400');
	searchBox=document.getElementById('txtSearch');
	searchBox.focus();
	gmarksObserver=new GmarksObserverControl();
	GMS.isSignedIn=GMS.checkSignedCookie();
	//window.setResizable(true);
	if (GMS.bookmarkArray.length>0){ 
		//visibleData=getVisibleData();
     	var treeLabels = document.getElementById("gmarkLabels");
     	lblsTreeView=new GMarksTreeView("labels");
     	//lblsTreeView.data=getVisibleData();
		treeLabels.view = lblsTreeView;
		treeLabels.selType="single";
		lblsTreeView.selection.select(0);
		
		var treeDetails = document.getElementById("gmarkDetails");
		if (lblsTreeView.data.length>0)
			treeView=new GMarksTreeView("details",lblsTreeView.data[0].fullTitle);
		else
			treeView=new GMarksTreeView("details","");
		//treeView.data=getVisibleData();
		treeDetails.view = treeView;
		treeView.openAll();
		treeDetails.selType="single";
		editField=document.getElementById("editableTxt");
	}
}

function debug(msg){
	var consoleService = Components.classes["@mozilla.org/consoleservice;1"]
    		.getService(Components.interfaces.nsIConsoleService);
  	consoleService.logStringMessage(msg);
}
