/*
 * Constants
{75B4ADD2-1159-484a-AAC4-75971C8DFD3C}
 *  */
const GMARKS_CONTRACTID = '@mozilla.org/gmarks;1';
const GMARKS_CID = Components.ID('{F443406C-961D-4ecc-BF39-C0E9943C72AE}');
const GMARKS_IID = Components.interfaces.nsIGMarksService;
function nsGMarksService() { 
	dump("started nsGMarks\n");
	this.wrappedJSObject = this;
	this.strbundle = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService)
					.createBundle("chrome://gmarks/locale/gmarks.properties");
	this.loadPrefs();
	dump("nsIGMarksService loaded\n");
	this.getBookmarksFeed("onload",false);
}
nsGMarksService.prototype = {
	bookmarkArray: new Array(),
	searchArray: null,
	recievedBookmarks: 0,
	isSignedIn: false,
	showIcons: true,
	showFavs: true,
	exHttps: false,
	sortBy: 'title',
	qsKey: "",
	qsKeyCode: 36,
	hidden: "",
	unlabeled: "",
	readerLabel: "Google Reader1",
	_tabGroup: null,
	validateFavs: false,
	toolbarFolder: null,
	toolbarShowIconsOnly: false,
	signingIn: false,
	loadPrefs: function(){
		var prefs = Components.classes["@mozilla.org/preferences-service;1"].
                            getService(Components.interfaces.nsIPrefService).getBranch("gmarks");
                            
		this.showIcons=prefs.getBoolPref('.showIcons');
		this.showFavs=prefs.getBoolPref('.showFav');
		this.exHttps=prefs.getBoolPref('.excludehttps');
		if (!this.showIcons){
			this.showFavs=false;
			this.exHttps=true;
		}
		this.exHttps=this.exHttps;
		this.sortBy=prefs.getCharPref('sortby');
		try{
			var t=prefs.getCharPref('.keys.quicksearch.key');
			prefs.clearUserPref('.keys.quicksearch.key');
		}
		catch(e){}
		this.qsKeyCode=prefs.getIntPref('.keys.quicksearch.key');
		this.hidden=prefs.getComplexValue(".hiddenLabels",
		      Components.interfaces.nsISupportsString).data;
		this.hidden=this.hidden.split(/\s*,\s*/);
		this.unlabeled=prefs.getComplexValue(".unlabeled",
		      Components.interfaces.nsISupportsString).data;
		this.readerLabel=prefs.getCharPref('.readerLabel');
		this.validateFavs=prefs.getBoolPref(".icons.validate");
		this.toolbarFolder=prefs.getComplexValue(".toolbarFolder",
		      Components.interfaces.nsISupportsString).data;
		this.toolbarShowIconsOnly=prefs.getBoolPref(".toolbarShowIconsOnly");
		this.nestedChar=prefs.getCharPref(".nestedChar");
		this.showCount=prefs.getBoolPref('.showCount');
	},
	set tabGroup(bkmks){
		this._tabGroup=new Array();
		for (var n=0;n<bkmks.length;n++){
			var bm=this.createNewBookmark();
			bm.url=bkmks[n].url;
			bm.title=bkmks[n].title;
			bm.labels=new Array();
			for (var j=0;j<bkmks[n].labels.length;j++)
				bm.labels.push(bkmks[n].labels[j]);
			bm.id=bkmks[n].id;
			bm.notes=bkmks[n].notes;
			this.updateBookmark(bm,n==(bkmks.length-1));
			this._tabGroup.push(bm);
		}
		this.doCommand("updateTabGroup");
	},
	//get bookmarkCount() {return bookmarkArray.length;},
	/*
	get value()       { return this.val; },
    set value(newval) { return this.val = newval; },
	 */
	getBookmark: function(index) {
		if (typeof index=='string'){
			//dump("used url - "+index+"\n");
			index=this.isBookmarked(index);
		}
		if (index>=0)
			return this.bookmarkArray[index];
		else
			return null;
	},
	setBookmark: function(index, aBookmark) {this.bookmarkArray[index]=aBookmark;},
	removeBookmark: function(bkmk,refresh){
		var idx=typeof bkmk=='number'?bkmk:this.isBookmarked(bkmk.url);
		if (idx>=0) {
			var id=this.bookmarkArray[idx].id;
			this.bookmarkArray.splice(idx,1);
			if (refresh) this.doCommand("quickrefresh");
			return id;
		}
		else
			return null;
	},
	updateBookmark: function(bkmk,refresh,idx){
		var d=new Date();
		bkmk.date=d.valueOf()*1000+d.getMilliseconds();
		if (idx==null){
			idx=this.getBookmarkIndex(bkmk);
			/*
			var original=idx;
			//dump("idx="+idx+"\n");
			//dump("actual="+this.isBookmarked(bkmk.url)+"\n");
			if (idx>=0) idx=this.isBookmarked(bkmk.url);
			if (idx==original){
				dump("GetBookmarkIndexWorked!\n");
			}
			else{
				dump("GetBookmarkIndex---FAILED!\n");
			}*/
		}
		var getNewImage=false;
		if (idx<0){
			idx=-idx+1;
			this.bookmarkArray.splice(idx,0,bkmk);
			getNewImage=true;
		}
		else if (this.bookmarkArray.length==0 || (idx==0 && this.bookmarkArray[0].url!=bkmk.url)){
			this.bookmarkArray.splice(0,0,bkmk);
			getNewImage=true;
		}
		else{
			if (this.bookmarkArray[idx].url==bkmk.url){
				bkmk.image=this.bookmarkArray[idx].image;
			}
			else
				getNewImage=true;
			this.bookmarkArray[idx]=bkmk;
		}
		if (getNewImage)
			this.getImage(idx,0);		
		if (refresh) this.doCommand("quickrefresh");
		if (idx>=0)
			return idx;
		else
			return -idx;
	},
	onRemoveBookmark : function(bm,star,refresh) { 
		var windowManager = Components.classes['@mozilla.org/appshell/window-mediator;1'].
				getService();
	    var windowManagerInterface = windowManager.QueryInterface(
	    		Components.interfaces.nsIWindowMediator);
	    var topWindowOfType = windowManagerInterface.getMostRecentWindow(
	    		"navigator:browser" );
	
	    if (topWindowOfType) {
	        if (bm.url==topWindowOfType.content.location.href){
				star=star?star:"off";
			 	Components.classes["@mozilla.org/observer-service;1"]
		         .getService(Components.interfaces.nsIObserverService)
		         .notifyObservers(null, "star-change", star);
			}
	    }
		var idx;
		if (typeof bm=='string') idx=this.isBookmarked(bm);
		idx=typeof idx=='number'?idx:this.isBookmarked(bm.url);
		var bkmk=this.bookmarkArray[idx];
		var id=this.removeBookmark(idx,refresh);	  
        this.send('dlq='+id,true,bkmk);
   	},
   	onRenameLabel: function(oldLabel, newLabel,refresh){
    	if (!newLabel || newLabel=="") {this.onRemoveLabel(oldLabel); return;}

		for (i=0; i < this.bookmarkArray.length; i++) 
	        for (j=0; j < this.bookmarkArray[i].labels.length; j++) 
	            if (this.bookmarkArray[i].labels[j] == oldLabel){
	                this.bookmarkArray[i].labels[j] = newLabel; break;
				}

    	this.send('op=modlabel&labels='+encodeURIComponent(oldLabel+','+newLabel),true);
    	if (refresh) this.doCommand("quickrefresh");
    },
    onRemoveLabel: function(label,refresh){
		for (i=0; i < this.bookmarkArray.length; i++) 
	        for (j=0; j < this.bookmarkArray[i].labels.length; j++) 
	            if (this.bookmarkArray[i].labels[j] == label){
	                this.bookmarkArray[i].labels.splice(j,1);
				}
    	this.send('op=modlabel&labels='+encodeURIComponent(label));
    	if (refresh) this.doCommand("quickrefresh");
    },
    addLabelToBookmark: function(bm,label,refresh){
    	if (label==null || label.length==0){
    		var prompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                        .getService(Components.interfaces.nsIPromptService);
           	var input = {value: ""};
           	var checked = {value: false};
			var result = prompts.prompt(null, "", 
					this.strbundle.GetStringFromName('addLabelToBookmarkPrompt'),
					input,null,checked);
			label=input.value;
			if (!result || label==null || label.length==0)
				return;
    	}
    	if (typeof bm=='string') 
    		bm=this.getBookmark(bm);
    	
    	if (this.hasLabel(bm.labels,label)) return;
    	var labels=label.split(/,\s*/);
    	for (var i=0;i<labels.length;i++){
			labels[i]=labels[i].replace(/^\s*|\s*$/g,"");
			if (labels[i].length==0 || labels[i]==" " || labels[i].match(/^\s+$/))
				labels.splice(i,1);
		}
		dump("addLabelToBookmark - labels: "+labels+"\n");
		bm.labels=bm.labels.concat(labels);//Add label
		this.updateBookmark(bm,refresh);
    	this.sendUpdateBookmark(bm);
    },
    removeLabelFromBookmark: function(bm,label,refresh){
    	if (typeof bm=='string') 
    		bm=this.getBookmark(bm);
    		
    	var newLabels=new Array();
    	
    	//this.removeBookmark(bm);
    	for (var i=0;i<bm.labels.length;i++){
    		if (bm.labels[i] != label)
    			newLabels.push(bm.labels[i]);
    	}
    	bm.labels=newLabels;
    	this.updateBookmark(bm,refresh);
    	this.sendUpdateBookmark(bm);
    },
    onRenameBookmark: function(bm,title,refresh){
    	if (title==null || title.length==0){
    		var prompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                        .getService(Components.interfaces.nsIPromptService);
           	var input = {value: bm.title};
           	var checked = {value: false};
			var result= prompts.prompt(null, "", 
				this.strbundle.GetStringFromName("renameBookmark"), input,null,checked);
			title=input.value;
			if (!result || title==null || title.length==0)
				return;
    	}
    	if (typeof bm=='string') 
    		bm=this.getBookmark(bm);
    	if (title){
			//id, url, title, labels, notes, date, image
    		var old=this.createNewBookmark(bm.id, bm.url, bm.title,bm.labels, bm.notes, 
    				bm.date,bm.image);
			this.removeBookmark(old);
			bm.title=title;    		
			this.updateBookmark(bm,refresh);
			this.sendUpdateBookmark(bm);
    	}
    },
    createNewBookmark: function(aId, aURL, aTitle, aLabels, aNotes, aDate, aImage, 
    		aService){//aId, aURL, aTitle, aLabels, aNotes, aDate, aImage
		if (aDate==null){
			var d=new Date();
			aDate=d.valueOf()*1000+d.getMilliseconds();
		}
		if (aLabels && typeof aLabels=="string") aLabels=[aLabels];
		aService=aService?aService:"bookmarks";
		return {
			id: aId, url: aURL, title: aTitle, 
			labels: aLabels?aLabels:new Array(), notes: aNotes?aNotes:"",
			date: aDate, image: aImage, serv: aService			
		};
		/*
		toString: function(){
				return 'id='+id +'&url='+url+ '&title='+title+'&labels='+labels+ '&notes='+notes;
		 */
	},
	getPassInfo: function(){
		var passwordManager = Components.classes["@mozilla.org/passwordmanager;1"]
	                                .getService(Components.interfaces.nsIPasswordManager);
		// the host name of the password we are looking for
		var queryString = 'chrome://gmarks';
		// ask the password manager for an enumerator:
		var e = passwordManager.enumerator;
		// step through each password in the password manager until we find the one we want:
		while (e.hasMoreElements()) {
		    try {
		        // get an nsIPassword object out of the password manager.
		        // This contains the actual password...
		        var pass = e.getNext().QueryInterface(Components.interfaces.nsIPassword);
		        if (pass.host == queryString) {
		             // found it!
		             return pass;
		        }
		    } catch (ex) {//Decrypting Failed
				continue;
		    }
		}
	},
	checkSignedCookie: function(){
		var cookieManager = Components.classes["@mozilla.org/cookiemanager;1"]
	                        .getService(Components.interfaces.nsICookieManager);
							
	    var i = cookieManager.enumerator; 
	
	    while (i.hasMoreElements()){
	        var cookie = i.getNext();
	        if (cookie instanceof Components.interfaces.nsICookie){
	            if (cookie.host == ".google.com")
	                if (cookie.name == "SID")
	                { 
                        return true;
	                }
	        }
	    }  
	    return false;
	},
	onSignIn: function(refresh,email,pass,action,sidebar,start,num) {
		var req = Components.classes["@mozilla.org/xmlextras/xmlhttprequest;1"]
                   .createInstance(Components.interfaces.nsIXMLHttpRequest);
		req.open("POST", 'https://www.google.com/accounts/ServiceLoginAuth', true); 
		req.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
		var data="ltmpl=wsad&ltmplcache=2&rm=false&Email="+email+"&Passwd="+pass;
		req.setRequestHeader('Content-Length', data.length);
		req.send(data);
		var GMS=this;
		req.onreadystatechange = function(ev){		
            if(req.readyState == 4) 
            {
				var status = -1;
			    try {status = req.status;}catch(e) {}
			    if(status == 200) {
					GMS.isSignedIn = GMS.checkSignedCookie();
			    }
			    if (GMS.isSignedIn && refresh )
		        	GMS.doCommand("retryreload");
		        else if (GMS.isSignedIn){
		        	GMS.getBookmarksFeed(action,sidebar,start,num);
		        }
		        else{
		        	GMS.recievedBookmarks=0;
		        	GMS.doCommand('onrefresh');
		        }
            }
		}
	},
	getBookmarksFeed: function(action,sidebar,start,num){
		dump("GMarks: getBookmarksFeed\n");
		this.recievedBookmarks=1;
		var prefs = Components.classes["@mozilla.org/preferences-service;1"].
		        getService(Components.interfaces.nsIPrefService).
		        getBranch("gmarks");
		var validate=this.validateFavs;
		var invalidlbls=prefs.getCharPref(".invalidlbls");
		var invalid=invalidlbls.split(/,\s*/);
		start=start?start:0;
		num=num?num:1000;
		var dom;//Bookmark info
	    this.isSignedIn = this.checkSignedCookie();
	    dump("GMarks isSignedIn="+this.isSignedIn+"\n");
		var auto=prefs.getBoolPref(".signin");
		if (auto && !this.isSignedIn){
			var pass=this.getPassInfo();
			if (pass){ 
				this.onSignIn(false,pass.user,pass.password,action,sidebar,start,num);
			}
			
		}
		else if (!this.isSignedIn){
			this.recievedBookmarks=0;
			this.doCommand('onrefresh');
		}
		var GMS=this;
		//this.bookmarkArray=new Array();
	    if (this.isSignedIn){
	        this.sortBy = prefs.getCharPref("sortby");
	        var req = Components.classes["@mozilla.org/xmlextras/xmlhttprequest;1"]
                   .createInstance(Components.interfaces.nsIXMLHttpRequest);
	         
	        // Asyncronous connection with Google Bookmarks server
	        req.open("GET", "http://www.google.com/bookmarks/lookup?output=rss&sort="+
	        		this.sortBy+"&start="+start+"&num="+num, true); 
	        req.send(null);
	        dump("GMarks RSS: Connecting... \n");
	        req.onreadystatechange = function(ev){
				//dump("readystate="+req.readyState+"\n");		
	            if(req.readyState == 4) 
	            {
					//dump("ready!\n");
	                var status = -1;
	                try {status = req.status} catch(e) {dump("error getting the status\n");}
					//dump("status="+status+"\n");
	                if(status == 200){
	                    dump("GMarks RSS: Connection worked! ("+req.status+")\n")
	                    if (dom = req.responseXML)
	                    {
	                       	var items = dom.documentElement.getElementsByTagName('item');	
							if (start==0) GMS.bookmarkArray=new Array(items.length);
							dump("GMarks RSS Items: "+GMS.bookmarkArray.length+"\n");
							var i=0;
							var badApples=0;
		                    for (i = 0; i<items.length; i=i+1) {  
		                    	var auxBookmark
								try{
		                        	auxBookmark = GMS.createNewBookmark();//{id: 0, url: null, title: null, labels: new Array(), notes: "", date: 0, image: null};
		                         	auxBookmark.labels = new Array();    
									try{
		                            	auxBookmark.id =    items[i].getElementsByTagName('bkmk_id')[0].childNodes[0].nodeValue;
									}
									catch(e){
										auxBookmark.id = 0;
										dump("GMarks - id error\n");
									}
									try{
										auxBookmark.url =   items[i].getElementsByTagName('link')[0].childNodes[0].nodeValue;
									}
									catch(e){
										auxBookmark.url = "about:blank";
										dump("GMarks - url error\n");
									}
									try{
										var tag=items[i].getElementsByTagName('bkmk_title'); 	
			                            if (tag.length>0)
											auxBookmark.title = tag[0].childNodes[0].nodeValue;
										else
											auxBookmark.title = auxBookmark.url;
									}
									catch(e){
										auxBookmark.title = auxBookmark.url;
										dump("GMarks - title error\n");
									}
									try{
										auxBookmark.date =GMS.convertDate(items[i].getElementsByTagName('pubDate')[0].childNodes[0].nodeValue);
									}
									catch(e){
										auxBookmark.date = 0;
										dump("GMarks - date error\n");
									}
		                            auxBookmark.notes = "";
		                            try{
			                            var auxLabelsArray = items[i].getElementsByTagName('bkmk_label');
			                            for (var j = 0; j < auxLabelsArray.length; j++){
			                                   	auxBookmark.labels.push(auxLabelsArray[j].childNodes[0].nodeValue);
			                            }
		                            }
			                        catch(e){
			                        	dump("GMarks - label error\n");
			                        }
	                           		GMS.bookmarkArray[i+start]=auxBookmark;
									if (GMS.showFavs){
										GMS.getImage(i+start,0);
									}
								}
								catch(e){
									dump("Error with bookmark\n");
									dump(e+"\n");
									dump("Title: "+auxBookmark.title+"\n");
									dump("URL: "+auxBookmark.url+"\n");
									dump("Labels: "+auxBookmark.labels+"\n");
									dump("ID: "+auxBookmark.id+"\n");
									dump("Date: "+auxBookmark.date+"\n");
									badApples++;
								}
							}
                        }
                        
                        if (badApples>0) dump("GMarks number of bad bookmarks = "+badApples+"\n");
						if (items.length==num){
							
							GMS.getBookmarksFeed(action,sidebar,start+1000,num);
						}
						else{
							if (GMS.readerLabel.length==0){
								GMS.recievedBookmarks=2;
								GMS.doCommand(action)
							}
							else
								GMS.getReaderStars(action);
						}
						              
					}
				}
			}   
	 	}//else if (sidebar) this.doCommand(action);
	},
	getSiteSearch: function(query, action, sidebar){
		var prefs = Components.classes["@mozilla.org/preferences-service;1"].
                            getService(Components.interfaces.nsIPrefService).getBranch("gmarks");
		var validate=this.validateFavs;
		var invalidlbls=prefs.getCharPref(".invalidlbls");
		var invalid=invalidlbls.split(/,\s*/);
		var dom;//Bookmark info
	    this.isSignedIn = this.checkSignedCookie();
		var auto=prefs.getBoolPref(".signin");
		if (auto && !this.isSignedIn){
			var pass=this.getPassInfo();
			if (pass) this.onSignIn(false,pass.user,pass.password);
		}
		var GMS=this;
	    if (this.isSignedIn){
	        this.sortBy = prefs.getCharPref("sortby");
	        var req = Components.classes["@mozilla.org/xmlextras/xmlhttprequest;1"]
                   .createInstance(Components.interfaces.nsIXMLHttpRequest);
	         
	        // Asyncronous connection with Google Bookmarks server
	        req.open("GET", "http://google.com/bookmarks/find?start=0&bkmk=1&output=rss&num=10000&q="+query, true); 
	        req.send(null);
	        dump("Search RSS: Connecting... \n");
	        req.onreadystatechange = function(ev){	
	            if(req.readyState == 4) 
	            {
	                var status = -1;
	                try {status = req.status} catch(e) {dump("error getting the status\n");}
	                
	                if(status == 200){
	                    dump("Search RSS: Connection worked! ("+req.status+")\n")
	                    if (dom = req.responseXML)
	                    {		  
	                       	var items = dom.documentElement.getElementsByTagName('item');	
							GMS.searchArray=new Array(items.length);
							dump("Search RSS Items: "+GMS.searchArray.length+"\n");
							var i=0;
	                        for (i = 0; i<items.length; i=i+1) {  
	                        	auxBookmark = GMS.createNewBookmark();//{id: 0, url: null, title: null, labels: new Array(), notes: "", date: 0, image: null};
	                         	auxBookmark.labels = new Array();    
								try{
	                            	auxBookmark.id =    items[i].getElementsByTagName('bkmk_id')[0].childNodes[0].nodeValue;
								}
								catch(e){
									auxBookmark.id = 0;
									dump("GMarks - id error\n");
								}
								try{
									auxBookmark.url =   items[i].getElementsByTagName('link')[0].childNodes[0].nodeValue;
								}
								catch(e){
									auxBookmark.url = "about:blank";
									dump("GMarks - url error\n");
								}
								try{
									auxBookmark.date =GMS.convertDate(items[i].getElementsByTagName('pubDate')[0].childNodes[0].nodeValue);
								}
								catch(e){
									auxBookmark.date = 0;
									dump("GMarks - date error\n");
								}
								try{
									var tag=items[i].getElementsByTagName('bkmk_title'); 	
		                            if (tag.length>0)
										auxBookmark.title = tag[0].childNodes[0].nodeValue;
									else
										auxBookmark.title = auxBookmark.url;
								}
								catch(e){
									auxBookmark.title = auxBookmark.url;
									dump("GMarks - title error\n");
								}
	                            auxBookmark.notes = "";
	                            try{
		                            var auxLabelsArray = items[i].getElementsByTagName('bkmk_label');
		                            for (var j = 0; j < auxLabelsArray.length; j++){
		                                   	auxBookmark.labels.push(auxLabelsArray[j].childNodes[0].nodeValue);
		                            }
	                            }
		                        catch(e){
		                        	dump("GMarks - label error\n");
		                        }
                           		GMS.searchArray[i]=auxBookmark;
                           		if (GMS.showFavs){
									GMS.getImage(i,1);
								}
	                        }
							dump("RSS Items: "+GMS.searchArray.length+"\n");
							//We don't need to wait for the notes because they will not be shown in the tree display.
							
							GMS.doCommand(action);		                   
						}
					}
				}
	        }
	    }else if (sidebar) this.doCommand(action);
	},
	getReaderStars : function(action){
		var req = Components.classes["@mozilla.org/xmlextras/xmlhttprequest;1"]
                   .createInstance(Components.interfaces.nsIXMLHttpRequest);
	    var userId="-";
	    var num=1000;
	    var validate=this.validateFavs;
	    req.open("GET", "http://www.google.com/reader/atom/user/"+userId+"/state/com.google/starred?n="+num+"&ck="+userId+
	    	"&client=scroll", true); 
	    req.send(null);
	    dump("GReader XML: Connecting... \n");
	    var GMS=this;
	    req.onreadystatechange = function(ev){
			//dump("readystate="+req.readyState+"\n");		
	        if(req.readyState == 4) 
	        {
				//dump("ready!\n");
	            var status = -1;
	            try {status = req.status} catch(e) {dump("error getting the status\n");}
				//dump("status="+status+"\n");
	            if(status == 200){
	                dump("GReader XML: Connection worked! ("+req.status+")\n")
	                if (dom = req.responseXML)
	                {		  
	                   	var items = dom.documentElement.getElementsByTagName('entry');	
						dump(items.length+" starred items\n");
						var i=0;
	                    for (i = 0; i<items.length; i++) {  
	                    	var auxBookmark;
							try{
								auxBookmark = GMS.createNewBookmark();//{id: 0, url: null, title: null, labels: new Array(), notes: "", date: 0, image: null};
								auxBookmark.id=1;
	                         	//auxBookmark.labels = new Array();    
								auxBookmark.serv="GReader";
								try{
									var categories=items[i].getElementsByTagName('category');
									for (var j=0;j<categories.length;j++){
										var term=categories[j].getAttribute('term');
										//dump(term+"\n");
										var pos
										var prefix='user/'+userId+'/label/';
										if ((pos=term.indexOf(prefix))!=-1){
											auxBookmark.labels.push(term.substring(pos+prefix.length));
										}
									}
								}
								catch(e){
									dump("error getting categories\n");
								}
								//dump("reader: "+GMS.readerLabel+"\n");
								auxBookmark.labels.push(GMS.readerLabel);
								try{
									auxBookmark.url =   items[i].getElementsByTagName('id')[0].getAttribute('gr:original-id');
								}
								catch(e){
									auxBookmark.url = "about:blank";
									dump("GReader - url error\n");
								}
								try{
									var tag=items[i].getElementsByTagName('title'); 	
		                            if (tag.length>0){
										auxBookmark.title = tag[0].childNodes[0].nodeValue;
										auxBookmark.title=auxBookmark.title.replace('&quot;','"');
		                            }
									else
										auxBookmark.title = auxBookmark.url;
								}
								catch(e){
									auxBookmark.title = auxBookmark.url;
									dump("GReader - title error\n");
								}//gr:crawl-timestamp-msec
								try{
									auxBookmark.date =   items[i].getAttribute('gr:crawl-timestamp-msec');
								}
								catch(e){
									auxBookmark.date = 0;
									dump("GReader - date error\n");
								}
								/*
								dump("Title: "+auxBookmark.title+"\n");
								dump("URL: "+auxBookmark.url+"\n");
								dump("Labels: "+auxBookmark.labels+"\n");
								dump("ID: "+auxBookmark.id+"\n");
								dump("Date: "+auxBookmark.date+"\n");
								*/
								var idx=GMS.updateBookmark(auxBookmark);
								if (GMS.showFavs){
									GMS.getImage(idx,0);
								}
							}
							catch(e){
								dump('error\n');
							}
						}
	                }	                           
				}
				GMS.recievedBookmarks=2;
				if (action.length>0){
                	GMS.doCommand(action);
                }  
			}
	    }
	},
	getID : function(bm){
		dump("get id: "+bm.title+"\n");
		var dom;//Bookmark info
    	this.isSignedIn = this.checkSignedCookie();
    	var GMS=this;
		if (this.isSignedIn){
	        var req = Components.classes["@mozilla.org/xmlextras/xmlhttprequest;1"]
                   .createInstance(Components.interfaces.nsIXMLHttpRequest);
	         
	        req.open("GET", "http://www.google.com/bookmarks/lookup?output=xml&sort=date&num=1", true); 
	        req.send(null);
	        req.onreadystatechange = function(ev){	
	            if(req.readyState == 4) {
	                var status = -1;
	                try {status = req.status} catch(e) {dump("error getting the status2\n");}
	                if(status == 200){
	                    if (dom = req.responseXML){		  
	                       	var item = dom.documentElement.getElementsByTagName('bookmark')[0];	
							var tmpBkmk={id: 0, url: null, title: null, labels: new Array(), notes: "", date: 0, image: null};//createNewBookmark();
                            tmpBkmk.id =    item.getElementsByTagName('id')[0].childNodes[0].nodeValue;
							tmpBkmk.url =   item.getElementsByTagName('url')[0].childNodes[0].nodeValue;
							tmpBkmk.date =  item.getElementsByTagName('timestamp')[0].childNodes[0].nodeValue;
							tmpBkmk.labels=new Array();
							var tag=item.getElementsByTagName('title'); 	
                            if (tag.length>0)
								tmpBkmk.title = tag[0].childNodes[0].nodeValue;
							else
								tmpBkmk.title = tmpBkmk.url;
							
							var idx=GMS.getBookmarkIndex(tmpBkmk);
							dump("Title: "+tmpBkmk.title+"\nURL: "+tmpBkmk.url+"\n");
							dump("IDX: "+idx+"\n");
							if (idx>=0){
								GMS.bookmarkArray[idx].id=tmpBkmk.id;;
								if (!GMS.validateFavs && GMS.showFavs){
									try{
										this.bookmarkArray[idx].image=this.getIcon(this.bookmarkArray[idx].url).spec;
									}
									catch(e){}
								}
								dump("id gotten! "+tmpBkmk.title+"|"+GMS.bookmarkArray[idx].title+"\n");
								GMS.doCommand("quickrefresh");
							}
							else{
								dump("Could not find bookmark with GETID\n");
							}
                        }
					}
					else
						dump("error getting the new id");
				}
			}
		}
	},
	getIcon : function(bmUrl){
		if (!this.showIcons || !this.showFavs) return null;
		var url = Components.classes['@mozilla.org/network/standard-url;1'].createInstance(Components.interfaces.nsIURI);
		url.spec = bmUrl;		
		if (!(url.scheme=="https" && this.exHttps)){
			var img = Components.classes['@mozilla.org/network/standard-url;1'].createInstance(Components.interfaces.nsIURI);
			img.spec = url.scheme + "://" + url.hostPort + "/favicon.ico";
			return img;
		}
		else{
			return null;
		}
	},
	getImage: function(bkmkIdx,type){
		if (!this.showIcons || !this.showFavs) return;
		type=type==null?0:type;
		if (!this.validateFavs) {
			if (type==0){
				this.bookmarkArray[bkmkIdx].image=
					this.getIcon(this.bookmarkArray[bkmkIdx].url).spec;
			}
			else{
				this.searchArray[bkmkIdx].image=
					this.getIcon(this.searchArray[bkmkIdx].url).spec;
			}
		}
		else{			
			var bkmk;
			if (type==0){
				bkmk=this.bookmarkArray[bkmkIdx];
			}
			else{
				bkmk=this.searchArray[bkmkIdx];
			}
			if (bkmk.image==null && bkmk.url.substring(0,4)=="http"){
				var img=this.getIcon(bkmk.url);
				if (img!=null){
					try{
						var uriChecker = Components.classes["@mozilla.org/network/urichecker;1"].createInstance()
									.QueryInterface(Components.interfaces.nsIURIChecker);				
						uriChecker.init(img);
						uriChecker.asyncCheck(new imageURIChecker(bkmkIdx,type),null);
					}
					catch(e){
						dump(e+"\n");
					}
				}
			}
		}
	},
	getImages : function(searching){
		if (!this.showIcons || !this.showFavs || !this.validateFavs) return;
		var bkmks=!searching?GMS.bookmarkArray:GMS.searchArray;
		this.favResponses=0;
		for (var i=0;i<bkmks.length;i++){
			this.getImage(bkmks[i],(searching==true?1:0));
			/*
			if (bkmks[i].url.substring(0,4)=="http" && bkmks[i].image==null){
				//dump(bkmks[i].url+"\n");
				var img=this.getIcon(bkmks[i].url);
				if (img!=null){
					try{
						var uriChecker = Components.classes["@mozilla.org/network/urichecker;1"].createInstance()
									.QueryInterface(Components.interfaces.nsIURIChecker);				
						uriChecker.init(img);
						uriChecker.asyncCheck(new imageURIChecker(i, bkmks[i],searching),null);
					}
					catch(e){
						dump(e+"\n");
					}
				}
			}*/
		}
	},
	convertDate: function(strDate){
		strDate=strDate.substring(5);
		var sections=strDate.split(" ");
		var day=sections[0];
		var monthStr=sections[1];
		var months=new Array("Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec");
		var month=months.indexOf(monthStr);
		var year=sections[2];
		var arrTime=sections[3].split(":");
		
		var date=new Date();
		date.setFullYear(year,month,day);
		date.setHours(parseInt(arrTime[0]),parseInt(arrTime[1])),parseInt(arrTime[2]);
		//dump("date: "+strDate+" - "+date.toString()+"\n");
		return date;
	},
	connectionError: function(bm){
		dump("connection error\n");
		if (bm!=null)
			this.doCommand("connectionerror",bm.url+"|"+bm.title);
	},
	send: function(data,async,bm){
		async=async!=null?async:true;
		var req = Components.classes["@mozilla.org/xmlextras/xmlhttprequest;1"]
                   .createInstance(Components.interfaces.nsIXMLHttpRequest);
    	req.open("POST", 'http://www.google.com/bookmarks/mark', async); 
		req.send(data);
		//dump("Send Data: "+data+"\n");
		//dump("Async: "+async+"\n");
		GMS=this;
		req.onreadystatechange = function() {
			//dump("readystate="+req.readyState+"\n");
			if(req.readyState == 4) {
				var status = -1;
				try {
					status = req.status;
				}
				catch(e) {
					dump("eror getting status aftr sending\n");
					dump("e="+e+"\n");
				}
				if(status != 200){
					GMS.connectionError(bm);
				}
				else{
					if (bm){
						if (bm.id==0)
							GMS.getID(bm);
					}
				}
			}
		}		
	},
	/*
	GBB_onQuickAddBookmark : function(event, title, url, labels, notes) {
    var theUrl = url ? url : window.content.location.href;
		var docTitle = title ? title : window.content.document.title;	
		var labels = labels ? labels : '';	
		var notes = notes ? notes : '';	

  	var req = new XMLHttpRequest();
    req.open("POST", 'http://www.google.com/bookmarks/mark', true); 
	req.send('q='+encodeURIComponent(theUrl)+'&title='+encodeURIComponent(docTitle)+'&labels='+labels+'&annotation='+notes);
	 */
	sendUpdateBookmark: function(bm,async){
		//dump("send update bookmark\n");
		//var data='q='+bm.url;
		
		var data='q='+encodeURIComponent(bm.url)+'&title='+encodeURIComponent(bm.title)
			+'&labels='+bm.labels+'&annotation='+bm.notes;
    	this.send(data,async,bm);
    		
    	
    	//async=async?async:true;
		/*
		var req = Components.classes["@mozilla.org/xmlextras/xmlhttprequest;1"]
                   .createInstance(Components.interfaces.nsIXMLHttpRequest);
        //var data='q='+encodeURIComponent(bm.url)+'&title='+encodeURIComponent(bm.title)+
    	//	'&labels='+encodeURIComponent(bm.labels.toString())+'&annotation='+encodeURIComponent(bm.notes);
    	req.open("POST", 'http://www.google.com/bookmarks/mark', false); 
		req.send(data);
		dump("Data: "+data+"\n");
		req.onreadystatechange = function(ev) {
			if(req.readyState == 4) {
				var status = -1;
				try {
					status = req.status }
				catch(e) {}
				if (status!=-1){
					dump("status="+req.statusText+"\n");
				}
				if(status != 200){
					dump("connection Error\n");
					//nsGMarksService.prototype.connectionError(bm);
				}
			}
		}*/
    },
    updateMultipleBookmarks: function(bkmks,i){
    	if (i==null){
    		for (var n=0;n<bkmks.length;n++){
    			this.updateBookmark(bkmks[n],n==(bkmks.length-1));
    		}
    		i=0;
    	}
    	GMS=this
    	if (i<bkmks.length){
	    	var req = Components.classes["@mozilla.org/xmlextras/xmlhttprequest;1"]
	                   .createInstance(Components.interfaces.nsIXMLHttpRequest);
	    	req.open("POST", 'http://www.google.com/bookmarks/mark', true); 
	    	var bm=bkmks[i];
			req.send('q='+encodeURIComponent(bm.url)+'&title='+encodeURIComponent(bm.title)+
    		'&labels='+encodeURIComponent(bm.labels)+'&annotation='+encodeURIComponent(bm.notes));
			req.onreadystatechange = function(ev) {
				if(req.readyState == 4) {
					var status = -1;
					try {
						status = req.status }
					catch(e) {}
					if(status != 200){
						GMS.connectionError(bm);
					}
					else
						GMS.updateMultipleBookmarks(bkmks,i+1);
				}
			}
    	}
    },
    reverseIt: function(s) {
        var a = s.split("");
        a = a.reverse();
        return a.join("");
    },
    doCommand: function(command,data){
    	dump("doCommand: gmarks-"+command+"\n");
    	if (command!=null)
	    	Components.classes["@mozilla.org/observer-service;1"]
		         .getService(Components.interfaces.nsIObserverService)
		         .notifyObservers(null, "gmarks-"+command, data);
	   
    },
    QueryInterface: function(iid) {
        if (!iid.equals(Components.interfaces.nsISupports) &&
            !iid.equals(GMARKS_IID))
            throw Components.results.NS_ERROR_NO_INTERFACE;
        return this;
    },
    getBookmarkIndex: function(value, a, startPos,endPos){//Binary Search
    	a=a?a:this.bookmarkArray;
    	//dump("alen="+a.length+'\n');
		startPos=startPos?startPos:0; endPos=endPos?endPos: a.length-1;
		if (this.sortBy=="title")
			return this.getTitleIndex(value,a,startPos,endPos);
		else
			return this.getDateIndex(value,a,startPos,endPos);
	},
	getTitleIndex: function(value,a,startPos,endPos){//Binary Search
		if (startPos==endPos){
			//this.GM_dump("both equal: "+value.title+" | "+a[startPos].title+"|"+startPos+"/"+a.length,value.title);
			if (value.url==a[startPos].url){
				//this.GM_dump("yaaaaaaaaay\n",value.title);
				return startPos; 
			}
			else if (value.title==a[startPos].title){
				//this.GM_dump('same title, diff url\n',value.title);
				try{
					for (var i=startPos+1;i<a.length;i++){
						if (value.url==a[i].url){
							//this.GM_dump(" i="+i);
							//this.GM_dump(" Higher-"+a[i].title+"---\n",value.title);
							return i;
						}
						else if (value.title!=a[i].title) break;
					}
					for (var i=startPos-1;i>0;i--){
						if (value.url==a[i].url){
							//this.GM_dump(" i="+i);
							//this.GM_dump(" Lower-"+a[i].title+"---\n",value.title);
							return i;
						}
						else if (value.title!=a[i].title) break;
					}
				}
				catch(e){
					//this.GM_dump(e+"\n");
				}
				//this.GM_dump("boooooooo\n",value.title);
				startPos=startPos*-1;
				//if (-startPos+1<a.length)
				//	startPos=startPos - (value.title<a[-startPos+1].title ? 1 : -1);
				return startPos;
			}
			else{
				//this.GM_dump("boooooooo\n",value.title);
				//try{this.GM_dump("Less: "+a[startPos-1].title+"\n",value.title);}catch(e){}
				//try{this.GM_dump("Right: "+a[startPos+1].title+"\n",value.title);}catch(e){}
				
				startPos= startPos*-1;
				//this.GM_dump("S: "+startPos+"\n");
				//this.GM_dump((startPos*-1<a.length)+"\n");
				if (startPos*-1<a.length){
					try{this.GM_dump("N: "+value.title<a[-startPos].title+"\n");}catch(e){}
					try{
						if (startPos*-1+1<a.length)
							this.GM_dump("U: "+value.title<a[startPos*-1+1].title+"\n");
					}
					catch(e){
						
					}
					startPos=startPos + (value.title<a[-startPos].title ? 0 : -1);
				}
				//this.GM_dump("Modified Pos: "+startPos+"\n",value.title);
				//try{this.GM_dump("inplaceof: "+a[-startPos].title+"\n",value.title);}catch(e){}
				
				return startPos;
			}
		}
		else if (startPos>endPos){
			//dump("greater - "+value.title+"|"+startPos+"\n",value.title);
			startPos++;
			//this.GM_dump("Real: "+this.isBookmarked(value.url)+"\n",value.title);
			return -1*startPos;
		}
		else{
			var midPoint=Math.floor(startPos + ((endPos-startPos)/2));
			//this.GM_dump("val: "+value.title+"  mid: "+a[midPoint].title+"   "+startPos+"|"+midPoint+"|"+endPos+"\n",value.title);
			
			if (value.url==a[midPoint].url){
				this.GM_dump("found match - "+value.title+"|"+midPoint+"\n",value.title);
				return midPoint;
			}
			else if (value.title==a[midPoint].title){
				//this.GM_dump('same title, diff url\n');
				for (var i=midPoint+1;i<a.length;i++){
					if (value.url==a[i].url)
						return i;
					else if (value.title!=a[i].title) break;
				}
				for (var i=midPoint-1;i>0;i--){
					if (value.url==a[i].url)
						return i;
					else if (value.title!=a[i].title) break;
				}
			}
			if (value.title.toLowerCase()<a[midPoint].title.toLowerCase()){
				//if(midPoint>0 && value.title.toLowerCase()>a[midPoint-1].title.toLowerCase()) {
					//this.GM_dump("inbetten > - "+value.title+"|"+midPoint+"\n");
					//return -midPoint;
				//}
				return this.getTitleIndex(value,a,startPos,midPoint-1);
			}
			else{
				//if(midPoint<a.length && value.title.toLowerCase()<a[midPoint+1].title.toLowerCase()) {
					//this.GM_dump("inbetten < - "+value.title+" - "+a[midPoint+1].title+"|"+midPoint+"\n");
					//return -midPoint;
				//}
				return this.getTitleIndex(value,a,midPoint+1, endPos);
			}
		}
	},
	GM_dump: function(msg,check){
		check=check?check:msg;
		if (check.indexOf("GMarks")>-1 || true){
			//dump(msg);
		}
	},
	getDateIndex: function(value,a,startPos,endPos){//Binary Search
		if (startPos==endPos){
			if (value.url==a[startPos].url){
				return startPos; 
			}
			else{
				return -startPos;
			}
		}
		else if (startPos>endPos){
			return -startPos;
		}
		else{
			var midPoint=Math.floor(startPos + ((endPos-startPos)/2));
			if (value.url==a[midPoint].url){
				return midPoint;
			}
			else{
				if (value.date<a[midPoint].date){
					//if(midPoint>0 && value.date>a[midPoint-1].date) {return -midPoint;}
					return this.getDateIndex(value,a,midPoint+1, endPos);
				}
				else{
					//if(midPoint<a.length && value.date<a[midPoint+1].date) {return -midPoint;}
					return this.getDateIndex(value,a,startPos,midPoint-1);
				}
			}
		}
	},
	getMatchingBookmarks: function(query){
		var matching=new Array();
		var secondMatching=new Array();
		var url2Matching=new Array();
		var lblsMatching=new Array();
		var notesMatching=new Array();
		var realStart;
		var urlPos=0;
		var pChar;
		query=query.toLowerCase();
		for (var i=0;i<this.bookmarkArray.length;i++){
			var bm=this.bookmarkArray[i];
			if ((realStart=bm.title.toLowerCase().indexOf(query))>-1 && (realStart==0 || bm.title.substring(realStart-1,realStart)==" ")){//(bm.title.substring(0,query.length).toLowerCase()==query){
				if (realStart==0)
					matching.push(bm);
				else
					secondMatching.push(bm);
				//break;
			}
			else if ((urlPos=bm.url.toLowerCase().indexOf(query))==0){
				matching.push(bm);
				//break;
			}
			else if ((realStart=bm.url.indexOf("://"))>-1
					&& bm.url.substring(realStart+3,realStart+3+query.length).toLowerCase()==query){
				matching.push(bm);
				//break;
			}
			else if (urlPos>0 && (pChar-bm.url.substring(urlPos-1,urlPos))=="." || pChar=="/" || pChar=="-" || pChar=="_" || pChar=="+")
				matching.push(bm);
			else if (urlPos>-1)
				url2Matching.push(bm);
			else if (bm.labels.toString().toLowerCase().indexOf(query)>-1){
				lblsMatching.push(bm);
				//break;
			}
			else if (bm.notes.toString().toLowerCase().indexOf(query)>-1){
				notesMatching.push(bm);
				//break;
			}
		}
		matching=matching.concat(secondMatching,url2Matching, lblsMatching, notesMatching);
		//matching=matching.concat(lblsMatching);
		//matching=matching.concat(notesMatching);
		return matching;
	},
    getBookmarkById: function(id){
	    var i;
	    for (i=0; i < this.bookmarkArray.length; i++) 
	  	if (this.bookmarkArray[i].id == id)
	        return this.bookmarkArray[i];
	    return false;	
	},	
	getBookmarksByLabel: function(label) {
	    var i, j;
	    var ret = new Array();
	    for (i=0; i < this.bookmarkArray.length; i++) 
	        for (j=0; j < this.bookmarkArray[i].labels.length; j++) 
	            if (this.bookmarkArray[i].labels[j] == label)
	                ret.push(this.bookmarkArray[i]);
					
		if (this.sortBy=="date"){
			//ret.sort(DateComparator);
		}
		
	    return ret;
	},	
	getLabels: function() {
	    var i, j;
	    var ret = new Array();
	    var source=this.bookmarkArray;
		//if (sortBy=="date"){
		//	source.sort(DateComparator);
		//}
		
		for (i=0; i < this.bookmarkArray.length; i++) {
	        for (j=0; j < this.bookmarkArray[i].labels.length; j++) 
	            if (!this.hasLabel(ret,this.bookmarkArray[i].labels[j]))//Every bookmark has some stupid smh^ label                this.bookmarkArray[i].labels[j].indexOf('^') == -1 && 
	                ret.push(this.bookmarkArray[i].labels[j]);
		}
	    if (this.sortBy=="title"){
			//Sort labels alphabetically
	    	ret.sort(function (x, y){ 	
				if (x.toString().toLowerCase() < y.toString().toLowerCase())
					return -1;
				else if (x.toString().toLowerCase() > y.toString().toLowerCase())
					return 1;
				return 0; 
			});
		}
	    return ret;
	},	
	hasLabel: function(ret, label) {
		for (var i=0;i < ret.length; i++){
			if (ret[i] == label)
				return true;
		}
		return false;
	},
	isBookmarked: function(url) {
	    var i;
	    for (i=0; i < this.bookmarkArray.length; i++) 
	        if (this.bookmarkArray[i].url == url)
	            return i;
	            
	    return false;
	},	
	getUnlabeled: function(){
		var ret=new Array();
		for (var i=0; i < this.bookmarkArray.length; i++)
			if (this.bookmarkArray[i].labels.length==0)
				ret.push(this.bookmarkArray[i]);
		
		return ret;
	},
	isInToolbar: function(bkmk){
		if (this.toolbarFolder.length==0)
			return false;
		if (bkmk.labels.indexOf(this.toolbarFolder)>-1)
			return true;
		for (var i=0;i<bkmk.labels.length;i++){
			if (bkmk.labels[i]+this.nestedChar==
					this.toolbarFolder.substring(0,bkmk.labels[i].length+this.nestedChar.length))
				return true;
		}
		return false;
	}
};
function imageURIChecker(idx,type)
{
	//dump("new imageURI Checker\n");
	this.idx  = idx;
	this.type = type;
	//this.isSearching=isSearching;
}

imageURIChecker.prototype =
{
	onStartRequest: function(request, context) {},
	onStopRequest: function(request, context, status)
	{
		var GMS=GMS=Components.classes["@mozilla.org/gmarks;1"]
                 .getService(Components.interfaces.nsIGMarksService).wrappedJSObject;
		if (status==0){
			if (this.type==0){
				GMS.bookmarkArray[this.idx].image=request.name;
				if (GMS.isInToolbar(GMS.bookmarkArray[this.idx]))
					GMS.doCommand("updateToolbarImage",GMS.bookmarkArray[this.idx].id+"\n"+
							GMS.bookmarkArray[this.idx].image);
			}
			else{
				GMS.searchArray[this.idx].image=request.name;
				if (GMS.isInToolbar(GMS.searchArray[this.idx]))
					GMS.doCommand("updateToolbarImage",GMS.searchArray[this.idx].id+"\n"+
							GMS.searchArray[this.idx].image);
			}
		}
		else{
			if (this.type==0)
				GMS.bookmarkArray[this.idx].image=null;
			else
				GMS.searchArray[this.idx].image=null;
		}
	}
}
var nsGMarksServiceModule = {
    registerSelf: function(compMgr, fileSpec, location, type) {
        compMgr =
compMgr.QueryInterface(Components.interfaces.nsIComponentRegistrar);
        compMgr.registerFactoryLocation(GMARKS_CID,
                                        "GMarks test",
                                        GMARKS_CONTRACTID,
                                        fileSpec,
                                        location,
                                        type);
    },
    getClassObject: function(compMgr, cid, iid) {
        if (!cid.equals(GMARKS_CID))
            throw Components.results.NS_ERROR_NO_INTERFACE;
        if (!iid.equals(Components.interfaces.nsIFactory))
            throw Components.results.NS_ERROR_NOT_IMPLEMENTED;
        return nsGMarksServiceFactory;   
    },
    canUnload: function(compMgr) { return true; }
};
var nsGMarksServiceFactory = {
    createInstance: function(outer, iid) {
        if (outer != null)
            throw Components.results.NS_ERROR_NO_AGGREGATION;
        if (!iid.equals(GMARKS_IID) &&
            !iid.equals(Components.interfaces.nsISupports))
            throw Components.results.NS_ERROR_INVALID_ARG;
        return new nsGMarksService();
    }
};
function NSGetModule(comMgr, fileSpec) { return nsGMarksServiceModule; }